﻿// Copyright (C) 2011 Oliver Sturm <oliver@oliversturm.com>. All rights reserved.

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Linq.Expressions;

namespace SelfConstructed.Complete {
  class Program {
    static void Main(string[] args) {
      // This is the expression we'd like to generate ourselves:
      Expression<Func<int, int>> squareExp = x => x * x;
      ExpressionDumper.Output(squareExp);

      var param = Expression.Parameter(typeof(int), "nx");
      var squareExp_ = Expression.Lambda<Func<int, int>>(
        Expression.Multiply(param, param),
        param);
      ExpressionDumper.Output(squareExp_);

      var square_ = squareExp_.Compile( );
      Console.WriteLine(square_(25));
    }
  }
}
